routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/online-shop', function (){
    return view('Template/Home');
});


Route::group(['prefix'=>'/online-shop'], function(){

    Route::resource('/User','UserController');
    Route::resource('/Book','BookController');
    Route::resource('/Category','CategoryController');
    Route::resource('/StatusOrder','OrderController');

    Route::get('/User/search/email','UserController@search')->name('User.search');
    Route::get('/StatusOrder/search/invoice_number','OrderController@search')->name('StatusOrder.search');
    Route::get('/Book/search/title','BookController@search')->name('Book.search');
    Route::get('/Category/search/category_name','CategoryController@search')->name('Category.search');
});

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    protected $primarykey = 'id';

    protected $fillable = [
        'username',
        'email',
        'address',
        'phone',
        'status',
        'avatar',
        'password'
    ];

    protected $hidden = [
        'remember_token'
    ];

    protected $casts = [
        'email_verified_at' => 'datetime'
    ];

public function order(){
    return $this->hasMany('App\Orders', 'user_id', 'id');
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Http\Request;
use App\User;



class UserController extends Controller
{

        public function index(){
           $User = User::paginate(5);
           return view('User.index',['User'=>$User]);
        }

        public function create()
        {
            return view('User.create');
        }

        public function show($id){
            $User = User::find($id);
            return view('User.show',['User'=>$User]);
        }

    public function store(Request $request)
    {

        $request->validate([
            'username'    =>  'required|min:8|max:32',
            'address'     =>  'required|max:50',
            'email'       =>  'required|unique:users|email',
            'password'    =>  'required|min:6|max:32',
            'phone'       =>  'required|min:11|max:13',
            'avatar'      =>  'required|image'
        ]);

        if($request->hasFile('avatar')){
            $gambar         = $request->file('avatar');
            $namepicture    = '/Picture/User/'.time().'.'.$gambar->getClientOriginalExtension();
            $directory      = public_path('/Picture/User');
            $gambar->move($directory, $namepicture);
        }

        User::create([
            'username'      =>  $request->username,
            'address'       =>  $request->address,
            'status'        =>  "ACTIVE","INACTIVE",
            'email'         =>  $request->email,
            'password'      =>  $request->password,
            'phone'         =>  $request->phone,
            'avatar'        =>  $namepicture
        ]);

        return redirect('/online-shop/User');
    }

    public function edit($id)
    {
                $User = User::find($id);
                return view('User.edit',['User'=>$User]);
    }

    public function update(Request $request, $id)
    {
        //
        $request->validate([
            'username'          => 'required|min:8|max:32', 
            'address'        => 'required|max:50',
            'email'         => 'required|email',
            'phone'       => 'required|numeric'
        ]);

        $User = User::find($id);
        $User->username = $request->username;
        $User->address  = $request->address;
        $User->email    = $request->email;
        $User->phone    = $request->phone;

        if($request->hasFile('avatar')){
            $gambar         = $request->file('avatar');
            $namepicture    = '/Picture/User/'.time().'.'.$gambar->getClientOriginalExtension();
            $directory      = public_path('/Picture/User');
            $gambar->move($directory, $namepicture);
        }else{
            $namepicture = $User->avatar;
        }

        $User->avatar = $namepicture;
        $User->save();

        return redirect('/online-shop/User');
    }
    
    public function destroy($id)
    {
        $User = User::find($id);
        $User->delete();
        return redirect('/online-shop/User');
    }  
    
    public function search(Request $request) {
        $searching = $request->searching;

        $User = User::where('email','LIKE', '%'.$searching.'%')->paginate();
        return view('User.index', ['User'=>$User]);
    }
}

resources/views/User/Show.blade.php
@extends('Template.Home')
    @section('title')
        Detail User
    @endsection

@section('content')
    <h1>Detail User</h1>
        <hr>
            <br>
            <div class="card bg-white border-info" style="max-witdh: 70%; margin: auto; min-height: 400px;">
                <div class="row" style="padding;25px">
                    <div class="col-md-2 offset-md-5 offset-sm-4">
                        <img src="{{asset($User->avatar)}}" style="height:150px; width:150px;" class="rounded-circle" alt="gambar">
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-12 text-center">
                        <h3>{{ $User->username }}</h3>
                    </div>
                </div>
                <hr>
                <br>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Email
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{ $User->email}}
                    </div>
                    <br>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Address
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{ $User->address }}
                    </div>
                    <br>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Phone
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{ $User->phone }}
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-2 offset-md-2 col-sm-3 offset-sm-2">
                        Status
                    </div>
                    <div class="col-md-4 col-sm-4">
                        {{ $User->status }}
                    </div>
                    <br>
                </div>
            </div>
@endsection

resources/views/User/create.blade.php
@extends('Template.Home')
@section('title')
    Create User
@endsection

@section('content')
    <div class="container">
        <h3>Create User</h3>
        <hr>
            <div class="card border-primary" style="max-width: 70%; margin: auto; margin-top: 40px;">
                <div class="card-header bg-primary text-white">
                    <h5>Create a New User</h5>
                </div>

                <div class="card-body">
                    <div class="contrainer text-primary">
                        <form action="{{ route('User.store') }}" class="form-group" method="POST" enctype="multipart/form-data">
                            @csrf
                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="username">Name</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="username" class="form-control" id="username" value="{{ old('username') }}">
                                        {{($errors->has('username')) ? $errors->first('username') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="email">Email</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="email" id="email" class="form-control" value="{{ old('email')}}" cols="30" rows="10">
                                        {{($errors->has('email')) ? $errors->first('email') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="password">Password</label>
                                    </div>

                                    <div class="col-md-8">
                                        <input type="password" name="password" id="password" class="form-control" value="{{ old('password')}} " cols="30" rows="10">
                                        {{($errors->has('password')) ? $errors->first('password') : ""}}
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="address">Address</label>
                                    </div>
                                    <div class="col-md-8">
                                        <textarea name="address" id="address" cols="20" rows="5" class="form-control" value="{{old('address')}}"></textarea>
                                        {{($errors->has('address')) ? $errors->first('address') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="phone">Phone</label>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="number" name="phone" id="phone" class="form-control" value="{{ old('phone')}}">
                                        {{($errors->has('phone')) ? $errors->first('phone') : ""}}
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3">
                                        <label for="status">Status</label>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-radio custom-control-inline">
                                            <input type="radio" name="status" id="ACTIVE" class="custom-control-input" value="ACTIVE">
                                                <label for="ACTIVE" class="custom-control-label">ACTIVE</label>
                                        </div>
                                        <div class="custom-control custom-radio custom-control-inline">
                                            <input type="radio" name="status" id="INACTIVE" class="custom-control-input" value="INACTIVE">
                                        </div>
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="input-group mb-3">
                                        <div class="col-md-3 text-primary">
                                            Avatar
                                        </div>
                                        <div class="col-md-8">
                                            <div class="custom-file">
                                                <label for="avatar" class="custom-the-label">Avatar</label>
                                                    <input type="file" name="avatar" id="avatar" class="custom-file-input">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <br>

                                <div class="row">
                                    <div class="col-md-3 offset-md-5 offset-sm-4">
                                        <button type="submit" class="btn btn-outline-primary">Create</button>
                                    </div>
                                </div>
                        </form>
                    </div>
                </div>
            </div>
      </div>
@endsection

resources/views/User/edit.blade.php
@extends('Template.Home')
    @section('title')
        Edit User
    @endsection

@section('content')
    <div class="container">
        <h3>Form Edit User</h3>
        <hr>

            <div class="card border-primary" style="max-width: 70%; margin:auto; margin-top:40px;">
                <div class="card-header bg-primary text-white">

                    <h5>{{ $User->username }}</h5>
                </div>

                <div class="card-body">
                    <div class="container text-primary">
                        <form action="{{ route('User.update',['id'=>$User->id]) }}" method="POST" class="form-group"
                        enctype="multipart/form-data">

                        @csrf
                        @method('PUT')
                            <div class="row">
                            <div class="col-md-3">
                                <label for="username" class="text-primary">Name</label>
                            </div>

                            <div class="col-md-8">
                                <input class="form-control" type="text" name="username" id="username" value="{{ $User->username }}">
                                {{ ($errors->has('username')) ? $errors->first('username'): ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="address" class="text-primary">Address</label>
                            </div>

                            <div class="col-md-8">
                                <input class="text-primary" name="address" id="address" type="text" value="{{ $User->address }} ">
                                {{ ($errors->has('address')) ? $errors->first('address') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="email" class="text-primary">Email</label>
                            </div>
                            <div class="col-md-8">
                                <input type="text" class="form-control" name="email" id="email" value="{{ $User->email }}">
                                {{ ($errors->has('email'))? $errors->first('email') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="phone" class="text-primary">Phone</label>
                            </div>
                            <div class="col-md-8">
                                <input type="number" name="phone" id="phone" class="form-control" value="{{ $User->phone }}">
                                {{ ($errors->has('phone')) ? $errors->first('phone') : ""}}
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3">
                                <label for="status" class="text-primary">Status</label>
                            </div>
                            <div class="col-md-8">
                                <select name="status" id="status" class="form-control">
                                    <option value="SUBMIT">SUBMIT</option>
                                    <option value="PROCESS">PROCESS</option>
                                    <option value="FINISH">FINISH</option>
                                    <option value="CANCEL">CANCEL</option>
                                </select>
                                    {{ ($errors->has('status')) ? $errors->first('status') : ""}}
                                </div>
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="input-group mb-3">
                                <div class="col-md-3 text-primary">
                                    Avatar
                                </div>
                                <div class="col-md-8">
                                    <img src="{{asset($User->avatar) }}" class="img-thumbnail"
                                    alt="gambar" height="150px" width="150px">
                                    <div class="custom-file">
                                         <label for="CustomFile" class="custom-file-label">Avatar</label>
                                             <input type="file" name="avatar" id="CustomFile" class="custom-file-input">
                                    </div>
                                    {{ ($errors->has('avatar')) ? $errors->first('avatar') : ""}}
                                </div>
                            </div>
                        </div>
                        <br>

                        <div class="row">
                            <div class="col-md-3 offset-md-5 offset-md-5">
                                <button type="submit" class="btn btn-outline-primary">Update</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
    </div>
@endsection

resources/views/User/index.blade.php
@extends('Template.Home')
            @section('title')
                List User
            @endsection
        @section('css')
        <style>
            body{
                padding-top: 30px;
            }

            th, td{
                padding: 10px;
                text-align: center;
            }

            td a{
                margin: 3px;
                align-content: center;
                color: white;
            }

            td a:hover{
                text-decoration: none;
            }

            td button{
                margin-top: 5px;
                cursor: pointer;
            }
        </style>
        @endsection
        @section('content')
            <div class="container">
                <h3> List User</h3><hr>
                    <div class="row">
                        <div class="col-md-2">
                            <a class="btn btn-outline-primary" href=" {{ route('User.create')}} ">
                                <span data-feather="plus-circle"></span>
                                New<span class="sr-only">(current)</span>
                            </a>
                        </div>
                        <div class="col-md-8">
                            <form action="{{ route('User.search') }}" class="form-inline" method="GET">
                                <div class="form-group mx-sm-3 mb-2">
                                    <input class="form-control" name="searching" placeholder="Search Email ..." value="{{ old('searching') }}" >
                                </div>
                                <button class="btn btn-primary mb-2" type="submit">Search</button>
                            </form>
                        </div>

                        <br>
                        <div class="table-responsive">
                        <table class="table table-striped">
                        <thead>
                            <tr class="table-primary">
                                <th scope="col">ID</th>
                                <th scope="col">Name</th>
                                <th scope="col">Email</th>
                                <th scope="col">Phone</th>
                                <th scope="col">Picture</th>
                                <th scope="col">Action</th>
                            </tr>
                        </thead>
                        <tbody>

                                @foreach ($User as $user)
                                    <tr>
                                        <td>{{ $user->id }}</td>
                                        <td>{{ $user->username }}</td>
                                        <td>{{ $user->email }}</td>
                                        <td>{{ $user->phone }}</td>

                                        <td>
                                            <img src="{{ asset($user->avatar) }}" alt="avatar" width="80px">
                                        </td>
                                        <td>
                                        <a class="btn-sm btn-primary" href="{{ route('User.show', ['id'=>$user->id]) }}">
                                            <span data-feather="eye"></span>Detail <span class="sr-only">(curret)</span>
                                        <a class="btn-sm btn-success d-inline" href="{{route('User.edit',['id'=>$user->id]) }}">
                                            <span data-feather="edit-2"></span>
                                            Edit <span class="sr-only">(current)</span>
                                        </a>
                                        <form class="d-inline" onsubmit="return confirm('Delete This User Permanently ?')"
                                        action="{{route ('User.destroy', $user->id) }}" method="POST">
                                            @csrf
                                                @method('DELETE')
                                                    <button type="submit" class="btn-sm btn-danger" value="Delete">
                                                        <span data-feather="trash"></span>
                                                        Delete
                                                        <span class="sr-only">(current)</span>
                                                    </button>
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                    {{$User->links()}}
                </div>
            </div>
        @endsection